﻿--[[Written by: David
Contact:
	In Game: Zalra @ Hyjal (Alliance)
	Email: Davieboy53@yahoo.com
	XFire: Dawnseclipse	
	Curse/Wowace/WowInterface Username: davie3
]]

WhoPinged = LibStub("AceAddon-3.0"):NewAddon("WhoPinged", "AceEvent-3.0", "AceConsole-3.0", "AceTimer-3.0")
local AceConfig = LibStub("AceConfigDialog-3.0");
local L = LibStub("AceLocale-3.0"):GetLocale("WhoPinged");
local BabbleClass = LibStub("LibBabble-Class-3.0"):GetLookupTable();

local PlayerWhoPinged;
local PingedMessage;
local ClassColor;
local hour,minute;
local BgDisable = false;

local PlayerNames = {};
local PlayerPings = {};

function WhoPinged:OnInitialize()
	WhoPinged:RegisterEvent("MINIMAP_PING", "MapPing")
	WhoPinged:RegisterEvent("PLAYER_ENTERING_WORLD", "EnteringWorldOnEvent")
	
	WhoPinged:RegisterChatCommand("whopinged", "ChatCommand")
	WhoPinged:RegisterChatCommand("wp", "ChatCommand")
	
	WhoPinged.db = LibStub("AceDB-3.0"):New("WhoPingedDB", WhoPinged.defaults, "profile");
	LibStub("AceConfig-3.0"):RegisterOptionsTable("WhoPinged", WhoPinged.options)
	AceConfig:AddToBlizOptions("WhoPinged", "Who Pinged?");
end

function WhoPinged:OnEnable()
	if (WhoPinged.db.profile.Disabled == false) then
		WhoPinged:Print("Enabled");
	else
		WhoPinged:Print("Disabled");
	end
end

function WhoPinged:ChatCommand()
	InterfaceOptionsFrame_OpenToCategory("Who Pinged?");
end

function WhoPinged:MapPing()
	if (WhoPinged.db.profile.Disabled == false) and (BgDisable == false) then
		WhoPinged:Ping(arg1)
	end
end

function WhoPinged:EnteringWorldOnEvent()
	local inInstance, instanceType = IsInInstance()
	if (inInstance == 1) and (instanceType == "pvp") then
		BgDisable = true;
	else
		BgDisable = false;
	end
end

function WhoPinged:Ping(UnitId)
	PlayerWhoPinged = UnitName(UnitId);	
	if (UnitIsVisible(UnitId) == 1) then
		if (WhoPinged:TableContain(PlayerWhoPinged, PlayerNames) == false) then
			table.insert(PlayerNames, PlayerWhoPinged);
		end		
		for k, v in pairs(PlayerNames) do
			if (PlayerPings[k]) then
				PlayerPings[k] = PlayerPings[k] + 1;
			else
				table.insert(PlayerPings, 1);
			end
		end
		
		if (WhoPinged.db.profile.ServerTime == false) then
			hour, minute = tonumber(date("%H")), tonumber(date("%M"));
		else
			hour,minute = GetGameTime();
		end
		if (hour >= 13) then
			hour = hour - 12;
		end
		
		PingedMessage = "|c"..WhoPinged:GetClassColor(UnitId).."".. PlayerWhoPinged .."|r |c00CCCCCC"..L["pinged the minimap at "];		
		if (minute < 10) then
			PingedMessage = PingedMessage.. hour .. ":0" .. minute;
		else
			PingedMessage = PingedMessage.. hour .. ":" .. minute;
		end
		if (WhoPinged.db.profile.ServerTime == true) then
			PingedMessage = PingedMessage.. L[" server time."].."|r"
		else
			PingedMessage = PingedMessage.. L[" local time."]
		end
		WhoPinged.PrintMessageTimer = WhoPinged:ScheduleTimer("PrintMessage", 2)
		if (WhoPinged.PrintMessageTimer) then
			WhoPinged:CancelTimer("PrintMessage", true)
			WhoPinged.PrintMessageTimer = nil;
			WhoPinged.PrintMessageTimer = WhoPinged:ScheduleTimer("PrintMessage", 2)
		end
		--if (not WhoPinged.PrintMessageTimer) then
			--WhoPinged.PrintMessageTimer = WhoPinged:CancelTimer(WhoPinged.PrintMessageTimer, true)
			--WhoPinged.PrintMessageTimer = WhoPinged:ScheduleTimer("PrintMessage", 2)
		--end
		--WhoPinged:Print(ChatFrame1, PingedMessage);
	end
end

function WhoPinged:PrintMessage()
	WhoPinged:CancelTimer("PrintMessage", true)
	WhoPinged.PrintMessageTimer = nil;
	for k, v in pairs(PlayerNames) do		
		PingedMessage = PingedMessage.. " ["..PlayerPings[k].."]".."|r"
	end
	WhoPinged:Print(PingedMessage);
	PlayerNames = table.wipe(PlayerNames);
	Playerpings = table.wipe(PlayerPings);
end

function WhoPinged:GetClassColor(UnitId)
	local localizedclass = UnitClass(UnitId);
	ClassColor = "";
	if (string.lower(localizedclass) == string.lower(BabbleClass["DEATHKNIGHT"])) then
		ClassColor = "00C41F3B";
	elseif (string.lower(localizedclass) == string.lower(BabbleClass["DRUID"])) then
		ClassColor = "00FF7D0A";
	elseif (string.lower(localizedclass) == string.lower(BabbleClass["HUNTER"])) then
		ClassColor = "00ABD473";
	elseif (string.lower(localizedclass) == string.lower(BabbleClass["MAGE"])) then
		ClassColor = "0069CCF0";
	elseif (string.lower(localizedclass) == string.lower(BabbleClass["PALADIN"])) then
		ClassColor = "00F58CBA";
	elseif (string.lower(localizedclass) == string.lower(BabbleClass["PRIEST"])) then
		ClassColor = "00FFFFFF";
	elseif (string.lower(localizedclass) == string.lower(BabbleClass["ROGUE"])) then
		ClassColor = "00FFF569";
	elseif (string.lower(localizedclass) == string.lower(BabbleClass["SHAMAN"])) then
		ClassColor = "002459FF";
	elseif (string.lower(localizedclass) == string.lower(BabbleClass["WARLOCK"])) then
		ClassColor = "009482CA";
	elseif (string.lower(localizedclass) == string.lower(BabbleClass["WARRIOR"])) then
		ClassColor = "00C79C6E";
	end
	
	if (ClassColor == nil) or (ClassColor == "") then
		ClassColor = "00CCCCCC";
	end
	
	return ClassColor;
end

function WhoPinged:TableContain(Value, Table)
	local ValueFound = false;
	for k, v in pairs(Table) do
		if (Value == v) then
			ValueFound = true;
			return true;
		end
	end
	if (ValueFound == false) then
		return false;
	end
end

